关闭

C++异常总结

标签: c语言c++异常exception
463人阅读 评论(0) 收藏 举报
分类:

C++异常

  • 为什么要用c++的异常处理机制?

    在我们平时写C语言程序时,经常出现会出现一些错误,有些是我们可以预测到的,这些我们可以通过返回错误码,或者设置回调函数打印错误信息等方法处理。但还有些程错误是我们不好预测的,如断错误,这时产生错误我们没有处理就会终止程序,然而我们经常运行程序后遇到错误不希望终止,如我们进程使用一些垃圾软件会闪退,这就是因为他门的程序异常没有处理好,所以遇到预测范围外的错误时,程序就会直接终止。所以为了解决这种情况,在C++里面就提出了异常处理机制,当一个函数无法处理产生的错误时,就抛出异常,让函数的调用者直接或者间接处理从错误。

  • C++异常处理的抛出与捕获

    当 throw 抛出异常时,就会暂停当前函数,先去当前函数里寻找同类型的catch异常捕获,如果当前函数没有,就释放当前函数的栈帧,去上一层函数里去找catch,这里是按照就近原则寻找catch,如果没有找到则退出程序。这个过程称为==栈展开==。

  • C++异常处理注意的地方

    1.代码中抛出异常对象后,会在函数调用链里与该对象类型匹配且离抛出异常处最近的catch匹配(==就近原则==)。

2.异常抛出后,会打乱程序执行流,会释放局部存储对象,因此在调试含异常的代码比较难调试。

3.异常抛出的类型必须和catch捕捉的类型必须匹配才可捕获,只有以下三种情况例外:

  • 允许非const对象到const对象的转换
  • ==允许派生类到基类的转换==,这一点很重要,因为库里的exception就用到了这条原理。
  • 将数组转换为指向数组的指针,将函数转换为指向函数的指针。

4.(==异常的再次抛出==)catch可以将收到的异常处理后再次抛给外层调用链,再由外层catch进一步处理。

5.记住!不要在析构函数里和构造函数里抛异常。分别可能会导致对象数据清理不完全,造成内存泄漏。可能会造成对象初始化不完全,在别人使用时可能调用都野指针。

  • ## C++的库里面提供了一种==exception==类

这个异常类有什么作用呢?

在写一些项目时,会分工不同的人来合作,那么有三个人来实现三个不同的功能的接口,我要调用他们三个人设计的接口,可是他们都使用了异常,但我又不知道他们抛出的异常都有什么类型,就算知道,在大型项目里也要常设计好多种类型的异常,我难道要每种类型设置一个catch吗?那怎么办呢?

class exception {
public:
    exception() throw();
    exception(const exception&) throw();
    exception& operator= (const exception&) throw();
    virtual ~exception() throw();
    virtual const char* what() const throw();
}

exception是一个抽象类基类,他们三个人在设计异常对象时可以使异常对象继承这个类,并重写基类里的what函数,what是用来展示异常原因的。那么我调用他们的接口就可以直接catch(exception&e),用基类类型就可以接收所有的子类异常了,通过e.what()就可以展示出异常信息,是不是很方便,如果不明白看下面栗子。

看下面模拟项目如何使用exception

#include<iostream>
#include<string>
#include<windows.h>
using namespace std;


class Exception
{
public:
    Exception(const string& msg, int id)
        :_errMsg(msg)
        , _errId(id)
    {}
    virtual string what()=0;
protected:
    string _errMsg;
    int _errId;
};

class connectException : public Exception//连接数据库异常
{
public:
    connectException(const string& Msg, int id)
        :Exception(Msg , id)
    {}

    virtual string what()
    {
        string msg = "【数据库错误:】";
        msg += _errMsg;
        return msg;
    }
};

class getinfoException : public Exception//获取数据异常
{
public:
    getinfoException(const string& Msg, int id)
        :Exception(Msg, id)
    {}
    virtual string what()
    {
        string msg = "【获取数据数据错误:】";
        msg += _errMsg;
        return msg;
    }
};
class echoException : public Exception//响应异常
{
public:
    echoException(const string& Msg, int id)
    :Exception(Msg, id)
    {}
    virtual string what()
    {
        string msg =  "【响应错误:】";
        msg += _errMsg;
        return msg;
    }
};

void connectsql()
{
    if (rand() % 5 == 0) //这里是模拟函数产生异常,以下雷同
    {
        throw connectException ("数据库连接错误", 1);
    }
    if (rand() % 3 == 0)
    {
        throw connectException ("网络错误",2);
    }
    cout << "【OK 数据库连接成功】" << endl;
}

void getinfo()
{
    if (rand() % 2 == 0)
    {
        throw getinfoException("获取数据失败", 101);
    }
    if (rand() % 3 == 0)
    {
        throw getinfoException("数据处理错误", 102);
    }
    cout << "【OK 获取客户端信息成功】" << endl;
}

void echoclient()
{
    if (rand() % 2 == 0)
    {
        throw echoException("响应错误", 202);
    }
    if (rand() % 3 == 0)
    {
        throw echoException("数据丢失", 203);
    }


    cout << "【OK 响应客户端成功】" << endl;
}

class HTTPserver
{
public:
    void start()
    {
        while (1)
        {
            try
            {
                connectsql();
                Sleep(1000);
                getinfo();
                Sleep(1000);
                echoclient();
                Sleep(1000);

            }
            catch (Exception& e)
            {
                cout << e.what() << endl;
            }
        }
    }
};

int main()
{
    HTTPserver h;
    h.start();


    return 0;
}

运行结果:
(http://img.blog.csdn.net/20170910194837817?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvZHJlYW1fMTk5Ng==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast)

C++异常的优点与缺点

优点:
1.可以清晰的展示出错误原因,不像返回错误码那么模糊
2.许多第三方库使用异常,因此容易与这些结合使用
3.在测试框架里使用比较方便
缺点:
1.会打断执行流,函数有可能不在该返回的地方返回,这样使得代码的管理和调试困难
2.异常安全要使用RAII和不同编码实践。加大了代码量,需要大量的支持。

0
0
查看评论

C++ 异常处理(三) exception类

1,exception 头文件: #include C++ 可以把它用作其它异常类的基类。 代码可以引发exception异常,也可以把exception用作基类, 在从exception派生而来的类中重新定义一个名为what()的虚拟成员函数, 它返回一个字符串,该字符串随实现而异。...
  • u010921682
  • u010921682
  • 2015-04-03 01:41
  • 4443

C++中异常类的使用方法

C++有很多的标准异常类:namespace std{    //exception派生    class logic_error; //逻辑错误,在程序运行前可以检测出来     //logic_e...
  • goodlixueyong
  • goodlixueyong
  • 2011-06-09 12:47
  • 26428

标准C++库中的异常类

在标准C++库中提供了一个异常类的基类exception和它的多个派生类。用于报告C++标准库中的函数在执行期间遇到的不正常情况。分别介绍如下。 1. 头文件中定义了异常类exception和bad_exception,异常类exception是标准C++库中所有异常类的基类。 2. 头文件中定...
  • wangyin159
  • wangyin159
  • 2015-06-22 15:21
  • 637

[C++]详解异常处理(Exception Handling) 及标准库异常处理类

详解异常处理(Exception Handling) 及标准库异常处理类 异常处理,英文名为exceptional handling, 是代替日渐衰落的error code方法的新法,提供error code 所未能具体的优势。异常处理分离了接收和处理错误代码。这个功能理清了编程者的思绪,也帮助...
  • stary_yan
  • stary_yan
  • 2016-04-30 11:00
  • 986

C++ - 异常类(exception classes) 的 详解 及 代码

C++ - 异常类(exception classes) 的 详解 及 代码 本文地址: http://blog.csdn.net/caroline_wendy/article/details/17498665 异常类(exception classes)包含4种基类, bad_c...
  • u012515223
  • u012515223
  • 2013-12-23 08:27
  • 3763

C++标准库异常类

C++标准库异常类继承层次中的根类为exception,其定义在exception头文件中,它是C++标准库所有函数抛出异常的基类,exception的接口定义如下: namespace std {         ...
  • zhq651
  • zhq651
  • 2012-12-24 16:27
  • 11037

深入理解C++异常

异常是指程序在运行时存在异常行为,这些异常的行为让函数不能正常执行。异常应该捕获的应该是你能够处理的错误,比如:不能连接服务器,不能连接数据库等,但异常不应该是你修复代码的bug的手段,比如:数组访问越界。死锁等情况。在异常处理中,你需要的做的是尽可能的修补你错误,比如:释放内存。解锁互斥量。 ...
  • SKY453589103
  • SKY453589103
  • 2015-11-16 10:56
  • 5379

C++异常(exception)第一篇--综合讲解

摘要:catch(exception &ex)是捕获所有标准库定义中的类std:exception;catch(...)则是捕获所有的异常。 1.简介    异常是由语言提供的运行时刻错误处理的一种方式。提到错误处理,即使...
  • CNHK1225
  • CNHK1225
  • 2016-03-25 11:23
  • 3548

c++ 使用throw抛出异常

抛出异常(也称为抛弃异常)即检测是否产生异常,在C++中,其采用throw语句来实现,如果检测到产生异常,则抛出异常。该语句的格式为: throw 表达式;     如果在try语句块的程序段中(包括在其中调用的函数)发现了异常,且抛弃了该异常,则这个异常就可以被try...
  • zzjxiaozi
  • zzjxiaozi
  • 2011-08-01 10:49
  • 82854

C++异常处理类与自定义异常处理类

例1:自定义一个继承自excepton的异常类myException C++标准中,定义在中的任何异常类都派生自exception Class,本例也只是简单地由exception继承,在try段抛出一个异常并捕捉。代码如下: /*++ test.cpp version:1.0 de...
  • makenothing
  • makenothing
  • 2015-01-29 16:44
  • 11776
    个人资料
    • 访问:50499次
    • 积分:1339
    • 等级:
    • 排名:千里之外
    • 原创:79篇
    • 转载:12篇
    • 译文:0篇
    • 评论:29条
    个人专属
    文章分类
    最新评论